sub my_action {
 ###############
  my ($out, $var, $ant, $prod);

  # header
    print "<script language='javascript'>document.getElementById('hl').innerHTML='Disk replace on $in{'member'}'</script>\n";


  if ($in{'answered'}) { &my_replace; }

 ###################################

 &load_lib('get-disk.pl');          # get required values
 &load_lib('get-zpool.pl');   # get required pool values


  &ask('begin');
  print "<table width='900'><tr><td valign='top'>";

  $var=&disklib_list('all_replaceable','pool,vdev,state,vendor,product,partcap');

  $var=~s/UNAVAIL/<font style='color:red'>UNAVAIL<\/font>/gs;
  $var=~s/FAULTED/<font style='color:red'>FAULTED<\/font>/gs;
  $var=~s/DEGRADED/<font style='color:red'>DEGRADED<\/font>/gs;
  $var=~s/REMOVED/<font style='color:red'>REMOVED<\/font>/gs;

  $var=~s/INUSE/<font style='color:blue'>INUSE<\/font>/gs;
  $var=~s/\bAVAIL/<font style='color:blue'>AVAIL<\/font>/gs;

  &ask('radio_defect','replace disk',$var,'','t450d200');
  print "</td><td style='padding-left: 30px' valign='top'>";

  if ($disk{'all_replaceable'} eq "") {
     print "disks: $txt{'none'}";
  } else {
     $var=&disklib_list('all_replacewith','state,vendor,product,partcap');

     $var=~s/\bAVAIL/<font color='blue'>AVAIL<\/font>/gs;
     &ask("radio_replacement","with",$var,'','t450d200');
  }
  print "</td></tr></table>";

  &ask('value_pool','force poolname (optionally needed with unavail disks)');
  &ask('confirm', $txt{'replace'},$txt{'proceed'});

  print "<br><br><a href=\"#\" onclick=\"\$('.info').toggle();\"><img src=\"/_doc/menu/ico/i16.png\"></a><br> \n";
  print <<EoF;
  <div class="info">
  $txt{'disk_repl_info'}
  </div>
EoF


  #status with disk cap and  model
    if ($cfg{'select_lang'}=~/my|app/i) {
         $prod="Product /Disks";
    } else {
         $prod="Product /napp-it";
    }
    if ($txt{'app_about_pools_product'} =~/\w+/) {
         $prod=$txt{'app_about_pools_product'};
    }
    $prod.=" " x16;
    $prod=substr($prod,0,16);


    $ant.=&exe("zpool status");
    my @l=split(/\n/,$ant);
    my ($s,$t,$k,$id);
    foreach my $l (@l) {
        $t=$l;
        $t=~s/^\s+//;

        if ($l=~/NAME/) { $l.="      Size           $prod   IOstat mess"; }

        if ($t=~/^c\d|^wwn|^scsi|^ata|^sd|lofi|^phys/) {      # is disk Solaris or Linux
             $t=~s/\s.*//;     # id only
             $t=~s/s0$|p0$//;  # no slices

             $id=$t;

             $k="$id"."_Size";
             $s=15-length($disk{$k});

             $l.="      $disk{$k}"." "x $s;
             $k="$id"."_product";
             $k=~s/p\d//;                        #disk not part
             $l.=$disk{$k};

             $l.="  ";
             $k="$id"."_error";
             $k=~s/p\d//;                        #iostat err

             @t=();
             $t=$disk{$k};
             $t=~s/.://g;
             @t=split(/ /,$t);
             $t=$disk{$k};
             #if ($t ne "") { &mess("-$t-"); }
             if (($t[1] > 9) || ($t[2] > 9))   {
               $t="<font style='color:blue; font-size: 11px'>  $t</font>";   # T:/H: values > 9
             }


             if ($l=~/lofi/) {
                  $k="$id";
                  $t="$disk{$k}";

                  $k="$id"."_options";
                  $t.="  $disk{$k}";
             }

             $l.=$t;

        }

    }
    $ant=join("\n",@l);


    print "<br><table style='width:100%'>\n";
    print "\t<tr>\n";
      print "<td class=\"td1_bg\" nowrap style=\"vertical-align:top; padding: 1 5 1 3; width:100%\">\n";
      print "<b>zpool status</b></td>";
    print "\t<tr>\n";

    print "\t<tr>\n";
      print "<td class=\"td2_bg\" nowrap style=\"vertical-align:top; padding: 1 5 1 3; width:100%\">\n";
      print "<pre>$ant</pre></td>";
    print "\t<tr>\n";

    print "</table>\n";


} #/ my_action



sub my_replace {
################

  # partition
  if ($in{'select_part_from'}=~/\d/) {
        $in{'radio_defect'}.="$in{'select_part'}";
  }

  # partition
  if ($in{'select_part_to'}=~/\d/) {
        $in{'radio_replacement'}.="$in{'select_part'}";
  }

   my $t="$in{'radio_defect'}\_pool";
   my $pool=$disk{$t};   #get pool of old disk

   if ($in{'value_pool'} ne "") {
      $pool=$in{'value_pool'};
   }

   if ($pool eq "") { &mess("Could not detect pool of disk $in{'radio_defect'}<br>please enter poolname manually");  }

#test
#&print_var("zpool replace \"$pool\" $in{'radio_defect'} $in{'radio_replacement'}");

   print "zpool replace -f \"$pool\" $in{'radio_defect'} $in{'radio_replacement'}<br>";

   my $i=&exe("ps zpool replace -f \"$pool\" $in{'radio_defect'} $in{'radio_replacement'}");

   if ($i ne "") {  $i=~s/error/<hr>error/; print $i; sleep(2); }

   print "Replace disk and reload disk-info<br>If the old disks keeps a pool member after resilver, set it to offline/online";

   $in{'l3'}="";
   sleep(1);
   reload;
}

 ###############################################
 #end of my script, do not delete the line below
 1;