use strict;         # check for proper code

###############
sub my_action {
###############     build actions according to this template


                        my ($out, $var);  # declare all your variables as local or you will get errors

                         # header
                         print "<script language='javascript'>document.getElementById('hl').innerHTML='restore Appliance Maps from a datapool (require a napp-it backup job)'</script>\n";

                        # declare later needed vars ($hour,..), used in auto.pl
                        use vars qw($date $hour $min $sec $source_ip);

                        ##################################################
                        # debug mode:
                        # create file /tmp/debug
                        # stop execution via
                        # print('message');  exit;  # message is displayed
                        ##################################################

                        # menue actions
                        ###############


                        ###############################################
                        # part 1: do function, if question is answered
                        ##############################################


                        if ($in{'submit_ok'} ne "") {      # submit
                            &restore_job;                  # do it
                        }

                        ##############################
                        # or create a form to ask user
                        ##############################

                        &my_ask;     # source target of sync


} #/ my_action


###########################
sub my_ask {   #  get job actions
###########################
    my (@source,@target,$s,$t,@g,$g,$r,@w,$w,$hostname,@h,$v);

        &ask('begin','b');
        print " <b style='background-color:#dddddd'>Restore appliance maps:</b> <br>You must have created a backup job to have data!!<br><br>";


        if ($in{'submit_ok'} ne "submit") { $in{'answered'} =""; }  #not klicked on submit but on select
        if ($in{'answered'}) { &restore_job;  }


        # backup from
        $t=$zfs{'datapools'}; $t=~s/\s/,/g;
        if ($in{'autoselect_pool'} eq "") {
             $in{'autoselect_pool'}=$t;  $in{'autoselect_pool'}=~s/,.*//; # first pool
        }

        &ask('autoselect_pool','Restore files from pool:',$t,$in{'autoselect_pool'});
        &ask('select_fs','Restore from filesystem',"/$in{'autoselect_pool'}/backup_appliance");


        #last backup date
        $t="-";
        if (-f "/$in{'autoselect_pool'}/backup_appliance/lastrun.log") {
            $t=`cat /$in{'autoselect_pool'}/backup_appliance/lastrun.log`;
            @h=split(/\n/,$t);
            if ($h[0]=~/\d/) { $t=$h[0]; }  else { $t="-";}
            #&print_array(@h);
        }
        &ask('select_date','Last backup date:',"$t");

        # maps
        &ask('select_nappit','restore appliance maps:','yes');

        print "<br>";
        print "</div><br><br>";
        &ask('confirm','submit','really? -restore will destroy a current map-');     # create job , start it manually

}



################################################################################################
sub restore_job {    # restore
################
  my ($t,$r,$d,@v,@m,$g);

  if ($in{'autoselect_pool'} eq "")     { &mess("datapool is missing"); }
  if (!($in{'select_date'} =~/\d/))     { &mess("backup date is missing"); }
  #&print_hash(%in);

  print "<br><br>restore appliance maps<br>";
         &exe("rm -r /var/web-gui/_log/maps/*");
         &exe("cp -R /$in{'autoselect_pool'}/backup_appliance/web-gui/_log/maps/. /var/web-gui/_log/maps");

         #change owner of /napp-it to web-account on every start of napp-it
         &exe("/usr/bin/chown -R napp-it /var/web-gui/_log/maps");

         #set permission to -R
         &exe("/usr/bin/chmod -R 700 /var/web-gui/_log/maps");      # sensitive data


   print "done.<br><br>";
   &log_end;
   sleep(1);
   $in{'l3'}="";
   &reload;
   exit;

} #/ write job
###############


###############################################
#end of my script, do not delete the line below
1;