#!
use strict;         # check for proper code

###############
sub my_action {
###############     build actions according to this template

print <<EoF;
<pre>ESXi hotsnaps<hr>

ESXi snaps are not a backup as you cannot restore a VM from a ESXi snap if the base VM file has problems.
You should never keep more than a few ESXi snaps for more than a few days. Main advantage of ESXi snaps
is the option to quiesce a guest filesystem (freeze io) or include memory/online state.

ZFS snaps are not limited in number or age. You can keep thousands and you can fully restore a VM from a ZFS snap.
Main problem with VMs is that a ZFS snap is like a sudden power down. There is no guarantee that a VM is not corrupted
in a ZFS snap.

You can combine the advantages of both when you include ESXi snaps in your ZFS snaps. In case of a restore you can rollback
a VM ex via SMB and Windows previous version or a ZFS rollback. You can then go back to the save ESXi snap within ESXi.

New Setup and Howto, see menu System > ESXi

</pre>
EoF
print "<script language='javascript'>\$('#hl').html('ESXi hotsnaps')</script>\n";

}
###############################################
#end of my script, do not delete the line below
1;