use strict;         # check for proper code

###############
sub my_action {
###############     build actions according to this template

  my ($out, $var, $color, @c, $r);  # declare all your variables as local or you will get errors

# monitorfile 1>>2>>3>>4>>5


$var=&exe('ps axw');
my @l=split(/\n/,$var);          # lines
@l=sort(@l);
print "<b style='background-color:#dddddd'>Activity monitor - auto-reload every 30s</b><br><br>";

# jobs
print "<b style='background-color:#dddddd'>Running jobs</b><br><br>";
foreach $t (@l) {

  $t=~s/\t/ /g;
  $t=~s/ +/ /g;
  $t=~s/\'+ *$//;

  if (!($t=~/job\-repli/)) { next; }
  if ($t=~/sudo/) { next; }     # otherwise double entries

  #receiver
  if ($t=~/job\-replicate/) {
    $r.= "$t\n";
  }

 #sender
  if ($t=~/job\-repli\-send/) {
    $r.= "-\t$t\n";
  }
}
$r="Receiver\tSender\n$r";
print &list2table($r,'100%,50%,50%');


$r="";
print "<br><br><b style='background-color:#dddddd'>Running processes</b><br><br>";
foreach $t (@l) {
  if (!($t=~/zfs receive|nc .* -l|zfs send|nc -w/)) { next; }
  if ($t=~/sudo/) { next; }     # otherwise double entries

  $t=~s/\t/ /g;
  $t=~s/ +/ /g;

 #receiver
  if ($t=~/zfs receive|nc .* -l/) {
    $r.= "$t\n";
  }

 #sender
  if ($t=~/zfs send|nc -w/) {
    $r.= "-\t$t\n";
  }
}
if ($r eq "") { $r="- no running replication processes -";}

$r="Receiver\tSender\n$r";
print &list2table($r,'100%,50%,50%');




#############  Pool
print "<br><br><b style='background-color:#dddddd'>Pool stat via iostat -v 1 2 2 </b><pre>";
$var=&exe('/usr/sbin/zpool iostat -v 1 2 2>&1');

# delete first stat
  $var=~s/\bpool //;
  $var=~s/.*\bpool/pool/s;

@l=split(/\n/,$var);

foreach $t (@l) {
  if ($t=~/^ /) { next; }             # insert -> disk or vdev
  if ($t=~/^-|^cache/) { next; }      # ----- or cache disk
  print "$t\n";
}


#############  I/O stat
print "<br><br><b style='background-color:#dddddd'>I/O stat via fsstat -F 1 2</b><pre>";
$var=&exe('fsstat -F 1 2');

# delete first stat
  $var=~s/new //;
  $var=~s/.*new/new/s;

@l=split(/\n/,$var);

foreach $t (@l) {
  if ((!($t=~/zfs/i)) && ($t=~/^\s*\d/)) { next; }
  print "$t\n";
}



###########
print "<br><br><b style='background-color:#dddddd'>net statistic</b><br>";

  &load_lib("get-current-net.pl");
  my @adapter=split(/\t/,$current{'link_phys'});

  foreach my $a (@adapter) {                #each adapter
        # statistik1
        print "<pre><br><b style='background-color:#dddddd'>Notice that netstat counts packets here, not MB/s</b><br><br>";
        $r=&exe("netstat -I $a 2 1");
        print "netstat -I $a";

        $r=~s/input.*output/input\t\toutput\t\t\tinput&nbsp;total\t\toutput&nbsp;total/;    #first field

        $r=~s/ /  /gs;
        $r=&list2table($r);
        print $r;

  }

   # header
    print "<script language='javascript'>document.getElementById('hl').innerHTML='$txt{'jobs_header'}'</script>\n";

} #/ my_action





###############################################
#end of my script, do not delete the line below
1;