###############
sub my_action {
###############

    #override with private functions?
    ##################################
    eval { &mylib_menue_folder_rename };                   # create this function in a private mylib.pl to replace this action

    my ($r, $z, @z, @w, $w, $n, @m, $i, $rp);

    # header
    print "<script language='javascript'>document.getElementById('hl').innerHTML='rename ZFS filesystem on $in{'member'}'</script>\n";

    ## admin only
    if (!($in{'id'}=~/admin/)) { &mess('Only allowed for admin, please logout and login as admin'); }

    #get zfs names
    $r=&exe("zfs list -t filesystem -H -o name");
    $r.="\n";
    $r.=&exe("zfs list -t filesystem -o name | grep / | grep rpool | grep -v ROOT | grep -v export");     # user fs on rpool
    @n=split(/\n/,$r);                       #names

    #get zfs mountpoints (to skip fs withount mountpoint)
    $r=&exe("zfs list -H -o mountpoint");
    @m=split(/\n/,$r);                       #mp
#&print_array(@n);

    for ($i=0; $i<=@n; $i++)   {
          #if ($sys{'auto_os'} ne "Linux") {
          #   if ($n[$i]=~/^$zfs{'syspool'}\b/) { next; }   # not syspool
          #}
          if ($n[$i]=~/^rpool\/VARSHARE/)      { next; }   # Solaris
        #  if (!($m[$i]=~/\//))                 { next; }   # no mountpoint # optional
          if (!($n[$i]=~/\//))                 { next; }   # no pools
          push(@z,$n[$i]);
    }
    $z=join("\t",@z);
    $z="-\t$z";

    #answered
    #########################################################################################
    if (($in{'answered'}) && ($in{'autoselect_zfs'} ne "-") && ( $in{'submit_ok'} ne "")) {
            $in{'value_new'}=~s/[^a-zA-Z0-9_\/\.\-:]//g;        # allowed in name
            $in{'value_new'}=~s/^\/+//g;                        # not allowed in name
            if ($in{'value_new'} eq "") {  &mess('invalid or empty name'); }


            my $new=$in{'autoselect_zfs'};
            my $pos=rindex($in{'autoselect_zfs'},"/");
            $new=substr($new,0,$pos+1).$in{'value_new'};

            $r=&exe("zfs rename $in{'autoselect_zfs'} $new");

            if ($r ne "") { print $r; sleep(2); }
            $in{l2}="";
            &reload;
    }
    ##########################################################################################

    #or form

    &ask('begin');
    &ask('autoselect_zfs',"$txt{'select'}",$z,$in{'autoselect_zfs'});

    $t=$in{'autoselect_zfs'}; $t=~s/.*\///; #name only
    &ask('value_new',"ZFS $txt{'rename_to'}",$t);
    &ask('confirm',$txt{'rename'},$txt{'proceed'});



} #/ my_action
##############

###############################################
#end of my script, do not delete the line below
1;
